今天我们继续来聊Rhino.Inside.Revit,在Grasshopper中玩转Revit~

在Revit中,可以利用过滤器选择想要的族类别下的所有图元,同样Grasshopper也可以根据族类别,选择所有图元。但是我们选择以后,是否可以重复利用呢?答案是肯定的,在Revit中,当你过滤好一类图元以后,是可以在修改上下文选项卡里,最右侧找到保存按钮,保存当前的选择集。

但是Revit只能根据族类别对图元进行过滤,而Grasshopper可以更精确的按参数进行过滤,并且在过滤完成以后,直接创建选择集,在需要使用的时候,直接在Revit内重新载入选择集即可。

例如,我们要过滤所有注释参数为“房间”的墙体,可以先选择所有墙体,然后根据参数过滤:

同时再创建一个参数过滤器,过滤“注释”的参数值为“房间”,然后通过一个“Logical And Filter”节点来将两个过滤器合并:

这样我们就可以通过“Query Elements”节点,很容易的根据前面的两个过滤器,过滤出我们需要的墙体:

到这一步都很顺利,但是要创建选择集的时候,我发现节点库里,并没有现成的创建选择集的节点,这时候,只能查询下API,看是不是可以通过代码解决了:

于是打开RevitAPI手册,搜索ionFilterElement的方法,我们可以看到:

  很简单就找到了创建方法,基本语法也超级简单,直接套用即可:

selset = ionFilterElement.(doc,name)

  但是实际写下来,发现还是有很多问题需要注意:

一个是,我们在创建选择集的时候,是要先判断项目中是否有同名选择集,因为有同名的是没法创建的,这里我们不需要删除该选择集,只需要将选择清空即可,之后我们可以向其添加选择的图元;

另一个就是,新创建的选择集是空的,我们需要向其添加选择的图元。用到的方法是:AddSet,语法如下:

将这两个问题想清楚了,就可以顺利的写代码了,完整代码如下:

    # Copyright(c) 2020, 九哥BIMer    import clr    clr.AddReference('System.Core')    clr.AddReference('RhinoInside.Revit')    clr.AddReference('RevitAPI')     clr.AddReference('RevitAPIUI')    from System import Enum, Action    import rhinoscriptsyntax as rs    import Rhino    import RhinoInside    import Grasshopper    from Grasshopper.Kernel import GH_RuntimeMessageLevel as RML    from RhinoInside.Revit import Revit, Convert    # 还可以添加扩展方法    # 这允许在Revit对象上调用.ToXXX()转换器方法    clr.ImportExtensions(Convert.Geometry)    from Autodesk.Revit import DB    from Autodesk.Revit.DB import *    # 访问活动文档对象    doc = Revit.ActiveDBDocument
    # 过滤要添加到选择集的图元    ids = list()    if not isinstance(E, list):      E = [E]    else:      E = E
    for e in E:        ids.append(e.Id)    itemset =set(ids)
    # 从模型中收集所有现有的过滤器     names = list()    collector = FilteredElementCollector(doc)    filters = collector.OfClass(FilterElement).ToElements();    selset = False
    t = Transaction(doc, '创建选择集')    t.Start()
    # 如果已经存在该名称的选择集,则删除其内容    for filter in filters:      if filter.Name == name:        filter.Clear()        selset = filter    # 创建一个新的选择集(如果不存在该选择集)    if selset == False:      selset = ionFilterElement.(doc,name)    # 将选择的图元添加到选择集    try:       selset.AddSet(itemset)      OUT = selset.ToDSType(False)    except: OUT = None    
    t.Commit()    print(OUT)

  这里分了几步编写代码:

1、收集要添加到选择集的图元,并获取ID列表;

2、获取模型中的选择集

3、判断模型中的选择集与要创建的选择集是否同名;

4、如果存在同名选择集,将其清空选择;

5、如果不存在同名选择集,新建选择集;

6、向选择集添加过滤的图元。

最后,放一张过滤墙体添加选择集的全图,供大家参考:

   

0

评论0

请先
施工现场定型化临边防护Revit绘制应用(模型可下载)
施工现场定型化临边防护Revit绘制应用(模型可下载)
6分钟前 有人购买 去瞅瞅看

社交账号快速登录

微信扫一扫关注
扫码关注后会自动登录网站